<template>
  <div>
    <div class="titSec">Datos de Sucursal</div>
    <v-card>
      <div class="gris">
        <v-row>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"></v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <div class="cotm">Region: {{ region }}</div>
          </v-col>

          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <div class="cotm">Zona {{ zona }}</div>
          </v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <div class="cotm">Territorio: {{ territorio }}</div>
          </v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"></v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <button v-if="btnE" class="btn" @click="editarCampos">Editar</button>
          </v-col>
        </v-row>
        <br />
        <v-row>
          <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <div class="subtitle-2">
              <strong>M² de Áreas</strong>
            </div>
          </v-col>
        </v-row>

        <br />
        <v-form ref="form" lazy-validation>
          <v-row>
            <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
              <v-text-field
                prefix="m²"
                :rules="[rules.required]"
                label="Total de Construcción*"
                rows="1"
                v-model="datos[0].valor"
                placeholder="Total de Construcción *"
                type="number"
                ref="txtTotalContruccion"
                :disabled="read"
                reverse
              />
            </v-col>
            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
              <v-text-field
                prefix="m²"
                :rules="[rules.required]"
                label="Presta Prenda *"
                rows="1"
                v-model="datos[1].valor"
                placeholder="Presta Prenda *"
                type="number"
                ref="txtPrestaPrenda"
                :disabled="read"
                reverse
            /></v-col>
            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
              <v-text-field
                prefix="m²"
                :rules="[rules.required]"
                label="Patio Bancario *"
                rows="1"
                v-model="datos[2].valor"
                placeholder="Patio Bancario *"
                type="number"
                ref="txtPPatioBancario"
                :disabled="read"
                reverse
            /></v-col>
            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
              <v-text-field
                prefix="m²"
                :rules="[rules.required]"
                label="Servicios *"
                rows="1"
                v-model="datos[3].valor"
                placeholder="Servicios *"
                type="number"
                ref="txtServicios"
                :disabled="read"
                reverse
            /></v-col>
            <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
          </v-row>
          <br />
          <v-row>
            <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
              <div class="subtitle-2">
                <strong>Información General </strong>
              </div>
            </v-col>
          </v-row>
          <br />
          <v-row>
            <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"
              ><v-text-field
                :rules="[rules.required]"
                label="Niveles*"
                rows="1"
                v-model="datos[4].valor"
                placeholder="Niveles*"
                type="number"
                ref="txtNiveles"
                :disabled="read"
                reverse
            /></v-col>

            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"
              ><v-text-field
                :rules="[rules.required]"
                label="No. de Ventanillas Banco Azteca*"
                rows="1"
                v-model="datos[5].valor"
                placeholder="No. de Ventanillas Banco Azteca*"
                type="number"
                ref="txtNVentanillasBAZ"
                :disabled="read"
                reverse
            /></v-col>

            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"
              ><v-text-field
                :rules="[rules.required]"
                label="No. de Ventanillas Presta Prenda*"
                rows="1"
                v-model="datos[6].valor"
                placeholder="No. de Ventanillas Presta Prenda *"
                type="number"
                ref="txtNVentanillasPP"
                :disabled="read"
                reverse
            /></v-col>

            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"
              ><v-text-field
                :rules="[rules.required]"
                label="No. de Asesores Banco Azteca*"
                rows="1"
                v-model="datos[7].valor"
                placeholder="No. de Asesores Banco Azteca*"
                type="number"
                ref="txtNAsesoresBAZ"
                :disabled="read"
                reverse
            /></v-col>

            <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"
              ><v-text-field
                :rules="[rules.required]"
                label="No. de Asesores Presta Prenda*"
                rows="1"
                v-model="datos[8].valor"
                placeholder="No. de Asesores Presta Prenda*"
                type="number"
                ref="txtNAsesoresPP"
                :disabled="read"
                reverse
            /></v-col>
            <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
          </v-row>
        </v-form>
        <br />
        <v-row>
          <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1"></v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"></v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2"></v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <button v-if="btn" class="btn" @click="validarCampos">Guardar</button>
          </v-col>
        </v-row>
      </div>
    </v-card>
    <ServiciosAlta :callbackGetFicha="callbackGetFicha" ref="servicioSucursales" />
  </div>
</template>
<script>
import store from "@/store";
import ServiciosAlta from "./ServicioAlta.vue";
const axios = store.state.axiosApiLocal;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  name: "Component-DatosSucursalPP",
  components: { ServiciosAlta },
  props: {
    value: Object,
    lectura: Boolean,
    guardarEditar: { type: Function },
    callbackInsertaDatosSucursal: { type: Function },
  },
  data() {
    return {
      datosRespaldo: [],
      datos: [
        {
          valor: null,
          descripcionZonaLayout: "Total de Construcción",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "Presta Prenda",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "Patio Bancario",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "Servicios",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "Niveles",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "No. de Ventanillas Banco Azteca",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "No. de Ventanillas Presta Prenda",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "No. de Asesores Banco Azteca",
          id: 0,
        },
        {
          valor: null,
          descripcionZonaLayout: "No. de Asesores Presta Prenda",
          id: 0,
        },
      ],
      idVersion: 0,
      region: "",
      zona: "",
      territorio: "",
      cantServInserta: 0,
      rules: {
        required: (value) => !!value || "Valor requerido.",
      },
      btn: true,
      btnE: false,
      read: false,
    };
  },
  mounted() {
    this.$refs.servicioSucursales.getFicha(this.value);
    if (this.lectura) {
      this.btn = false;
      this.btnE = false;
      this.read = true;
    }
    this.cargaCatalogo();
    this.cargaDatosZonasPorDocumento();
  },
  methods: {
    callbackGetFicha(region, zona, territorio) {
      this.region = region;
      this.zona = zona;
      this.territorio = territorio;
    },
    editarCampos() {
      this.btn = true;
      this.btnE = false;
      this.read = false;
      this.guardarEditar(false);
    },
    validarCampos() {
      this.$refs.form.validate();
      if (this.$refs.form.validate()) {
        console.log(true);
        this.btn = false;
        this.btnE = true;
        this.read = true;
        this.guardarEditar(true);
        this.diferencias();
      } else {
        console.log(false);
        this.guardarEditar(false);
      }
    },
    cargaCatalogo() {
      this.resetDatos();
      var idNegocio = this.value.dataUnidadNegocio.value.idNegocio;
      if (idNegocio && !this.lectura) {
        if (idNegocio == "-1") {
          idNegocio = this.value.idNegocio;
        }
        axios("/documento-sucursal/negocio-zona/v1/" + idNegocio + "/zona/0")
          .then((response) => {
            let data = response.data;
            if (data) {
              console.log(data.resultado);
              if (data.resultado && data.resultado.length > 0) {
                data.resultado.map((i) =>
                  this.datos.map((j) => {
                    if (i.descripcionZonaLayout == j.descripcionZonaLayout) {
                      j.id = i.idZona;
                    }
                  })
                );
                console.log(JSON.stringify(this.datos));
                this.cargaDatosZonasPorDocumento();
              }
            }
          })
          .catch((error) => {
            if (error.response) {
              console.log(error.response.data);
            }
          });
      } else {
        this.cargaDatosZonasPorDocumento();
      }
    },
    cargaDatosZonasPorDocumento() {
      this.idVersion = 0;
      let body = {
        idCeco: this.value.dataCeco.ceco,
      };
      axios
        .post("/documento-sucursal/dato-zona/v1/zona/ceco/", body)
        .then((response) => {
          let data = response.data;
          console.log("cargaDatosZonasPorDocumento=>" + JSON.stringify(data.resultado));
          if (data && data.resultado) {
            data.resultado.map((d) =>
              this.datos.map((dlocal) => {
                if (d.descripcion == dlocal.descripcionZonaLayout) {
                  if (!dlocal.valor) {
                    dlocal.valor = d.valorMetros;
                    this.cargarVersion(d.idVersion);
                  }
                }
              })
            );
            this.copiarDatos();
          }
        })
        .catch((er) => {
          if (er.response) {
            console.log(er.response.data);
          }
        });
    },

    copiarDatos() {
      this.datosRespaldo = JSON.parse(JSON.stringify(this.datos));
    },

    diferencias() {
      var idNegocio = this.value.dataUnidadNegocio.value.idNegocio;
      var diferencias = false;
      if (
        idNegocio &&
        idNegocio == "-1" &&
        !this.lectura &&
        this.datosRespaldo.length > 0
      ) {
        for (var i = 0; i < this.datos.length; i++) {
          if (this.datos[i].valor != this.datosRespaldo[i].valor) {
            diferencias = true;
            break;
          }
        }
      }
      if (diferencias) {
        this.insertaDatos();
      }
    },

    resetDatos() {
      this.datos.map((d) => {
        d.valor = null;
        d.id = 0;
      });
      this.datosRespaldo = [];
    },

    cargarVersion(idVersion) {
      var idNegocio = this.value.dataUnidadNegocio.value.idNegocio;
      if (idNegocio && idNegocio == "-1" && !this.lectura && idVersion != 0) {
        this.idVersion = idVersion;
      }
      console.log("idVersion=>" + this.idVersion);
    },

    insertaDatos() {
      console.log("Inicia envio de datos sucursales");
      var version = 1;
      if (this.idVersion != 0) {
        this.idVersion = this.idVersion + 1;
        version = this.idVersion;
      }
      this.cantServInserta = 0;
      let idFolio = this.value.folio.idFolio;
      this.datos.map((j) => {
        if (j.id) {
          var body = {
            idCatalogoZona: j.id,
            idVersion: version,
            idFolio: idFolio,
            observaciones: j.descripcionZonaLayout,
            valor: j.valor,
          };
          axios
            .post("/documento-sucursal/dato-zona/v1/", body)
            .then((response) => {
              this.llamadoCallback(body);
            })
            .catch((err) => {
              if (err.response) {
                console.log(err.response.data);
                this.llamadoCallback(body);
              }
            });
        }
      });
    },
    llamadoCallback(body) {
      this.cantServInserta = this.cantServInserta + 1;
      if (this.cantServInserta < this.datos.length) {
        console.log(JSON.stringify(body));
      } else {
        console.log("Termino de enviar datos sucursales");
        this.copiarDatos();
        this.callbackInsertaDatosSucursal();
      }
    },
  },
};
</script>
